#include <unistd.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <usb.h>

#include "dcdcusbconst.h"
#include "dcdc.h"

static int spam_msg(usb_dev_handle *dev);

int main() {
	usb_dev_handle *dev = dcdc_open();

	if(NULL == dev) {
		fprintf(stderr, "Can't continue without device\n");
		return -1;
	}

	while(1) {
		spam_msg(dev);
		sleep(1);
	}

	dcdc_close(dev);
	return 0;
}

int spam_msg(usb_dev_handle *dev) {
	int error;
	int mode;

	uint8_t data[64];
	error = dcdc_get_all_values (dev);
	if(error < 0) {
		fprintf(stderr, "failed send command get all values\n");
		dcdc_close(dev);
		return -1;
	}

	error = dcdc_read_status (data, dev);
	if (error < 0) {
		fprintf(stderr, "Failed read_status\n");
		dcdc_close(dev);
		return -1;
	}

	switch(data[0]) {
		case DCDCUSB_RECV_ALL_VALUES:
			{
				mode = data[1];

				//stat.add("mode", mode & 0x3);
				//stat.add("time config", (mode >> 5) & 0x7);
				//stat.add("voltage config", (mode >> 2) & 0x7);

				//stat.add("state", (int)data[2]); //7=good, 18= 1 minute to off
				// powerState.state = data[2];
				printf("state=%02x\n", data[2]);

				float input_voltage = ((float)data[3] * 0.1558f);
				//stat.add("input voltage", input_voltage);
				// powerState.input_voltage = input_voltage;

				float voltage = (float)data[4] * 0.1558f;
				//stat.add("ignition voltage", voltage);

				float output_voltage = (float)data[5] * 0.1170f;
				//stat.add("output voltage", output_voltage);
				// powerState.output_voltage = output_voltage;

				int status = data[6];
				//stat.add("Power Switch", ((status & 0x4) ? "True":"False"));
				// powerState.power_switch = (status & 0x4);
				//stat.add("Output Enable", ((status & 0x8) ? "True":"False"));
				// powerState.output_enable = (status & 0x8);
				//stat.add("AuxVin Enable", ((status & 0x10) ? "True":"False"));
				// powerState.aux_enable = (status & 0x10);

				//ss.str("");
				//ss << "version " << ((data[23] >> 5) & 0x07) << "." << (data[23] & 0x1F);
				//stat.add("version", ss.str());

				//msg_out.status.push_back(stat);

				printf("mode=%x input_voltage=%.2f ignition_voltage=%.2f output_voltage=%.2f\n", 
                		mode, input_voltage, voltage, output_voltage );
			}
			break;
		case INTERNAL_MESG:
			break;
		case DCDCUSB_MEM_READ_IN:
			break;
		case DCDCUSB_CMD_IN:
			{
				printf("received CMD_IN");
				//fprintf(stderr,"%x %x %x %x\n", data[0], data[1], data[2], data[3]);

				double rpot = ((double)data[3]) * CT_RP / (double)257 + CT_RW;
				double voltage = (double)80 * ( (double)1 + CT_R1/(rpot+CT_R2));
				voltage = floor(voltage);
				voltage = voltage/100;
				//stat.add("voltage", voltage);
				printf("vout=%f", voltage);
				//msg_out.status.push_back(stat);
			}
			break;
		default:
			printf("un-recognized message type = %x\n", data[0]);
	}



}

